/* Fichiers.cpp : Fonctions de gestion des fichiers du Club Vido
 * Auteurs      : M.M.
 * Cration     : juin 1998
 */
#include <fstream>
#include <string>
#include <stdcpp>
using namespace std;
#include "p270-Fichiers.h"

/*****
 * CreerFichiers : Cre les fichiers de films, d'abonns et de locations
 *                 s'ils n'existent pas.
 */
void CreerFichiers()
    {
    ofstream ficFilms(FICHIER_FILMS, ios_base::app);
    ofstream ficAbonnes(FICHIER_ABONNES, ios_base::app);
    ofstream ficLocations(FICHIER_LOCATIONS, ios_base::app);
    }

/*****
 * Fonctions pour fichier des films du club vido
 * Champs : 
 * noFilm    : int     entre NO_FILM_MIN et NO_FILM_MAX
 * titre     : string  complet ou simplifi pour ne pas tre trop long (non valid)
 * categorie : char    code reprsentant la catgorie (pour la liste des codes et
 *                     leur signification, voir la fonction NomCompletDeCategorie)
 * duree     : int     en minutes (valid >= 1)
 */
bool Lire(istream& p_ficFilms, 
          int& p_s_noFilm, string& p_s_titre, char& p_s_categorie, int& p_s_duree)
    {
    p_ficFilms >> p_s_noFilm;
    p_ficFilms >> ws; getline(p_ficFilms, p_s_titre, '\t');
    p_ficFilms >> p_s_categorie >> p_s_duree;

    return p_ficFilms.good();
    }

void Ecrire(ostream& p_ficFilms, 
            int p_noFilm, string p_titre, char p_categorie, int p_duree)
    {
    p_ficFilms << p_noFilm << '\t' << p_titre << '\t' << p_categorie << '\t' 
               << p_duree << endl;
    }

/*****
 * Fonctions pour fichier des abonns
 * Champs :
 * noAbonne  : int        allou squentiellement dans le fichier
 * nom       : string     nom (+ prnom) de l'abonn (non valid)
 * adresse   : string     adresse complte (non valid)
 * telephone : string     no de tlphone (non valid)
 */
bool Lire(istream& p_ficAbonnes, 
          int& p_s_noAbonne, string& p_s_nom, string& p_s_adresse, 
          string& p_s_telephone)
    {
    p_ficAbonnes >> p_s_noAbonne;
    p_ficAbonnes >> ws; getline(p_ficAbonnes, p_s_nom, '\t');
    getline(p_ficAbonnes, p_s_adresse, '\t');
    getline(p_ficAbonnes, p_s_telephone);

    return p_ficAbonnes.good();
    }

void Ecrire(ostream& p_ficAbonnes, 
            int p_noAbonne, string p_nom, string p_adresse, string p_telephone)
    {
    p_ficAbonnes << p_noAbonne << '\t' << p_nom << '\t' << p_adresse << '\t' 
                 << p_telephone << endl;
    }

/*****
 * Fonctions pour fichier des locations de films
 * Champs :
 * noAbonne     : int         abonn qui loue le film
 * noFilm       : int         numro du film lou
 * dateLocation : string      date de la location (non valid)
 * prixLocation : double      prix de la location selon type de film
 */
bool Lire(istream& p_ficLocations, 
          int& p_s_noAbonne, int& p_s_noFilm, string& p_s_dateLocation,
          double& p_s_prixLocation)
    {
    p_ficLocations >> p_s_noAbonne >> p_s_noFilm;
    p_ficLocations >> ws; getline(p_ficLocations, p_s_dateLocation, '\t');
    p_ficLocations >> p_s_prixLocation;

    return p_ficLocations.good();
    }

void Ecrire(ostream& p_ficLocations, 
            int p_noAbonne, int p_noFilm, string p_dateLocation,
            double p_prixLocation)
    {
    p_ficLocations << p_noAbonne << '\t' << p_noFilm << '\t' 
                   << p_dateLocation << '\t' << p_prixLocation << endl;
    }
